from read_cifar import *
from collections import Counter

def compute_distance(m1, m2):
    if m1.shape != m2.shape:
        raise ValueError("Dimensions must be identical")
    #distance = np.linalg.norm(m1 - m2)
    x = (m1 - m2) ** 2
    y = np.sum(x)
    dist = np.sqrt(y)

    return dist
def distance_matrix(data_train, data_test):
    dists = []

    for test in data_test:
        dist = []
        for train in data_train:
            dist.append(compute_distance(test, train))
        dists.append(dist)

    return dists

def knn_predict(dists, labels_train, k):
    predictions=[]
    for distances in dists:
        min_indexes = np.argpartition(distances, k)[:k]
        possible_pred = labels_train[min_indexes]
        counted = Counter(possible_pred)
        pred = counted.most_common(1)[0][0]
        predictions.append(pred)
    return predictions

def evaluate_knn(predictions, labels_test):
    sum=0
    for i in range(len(predictions)):
        if predictions[i] == labels_test[i]:
            sum+=1

    return sum / len(predictions)

'''def evaluate_knn(data_train , labels_train,data_test ,labels_test, k):
        
    return'''

def main():
    folder_path = 'data/cifar-10-batches-py'
    data, labels = read_cifar(folder_path)

    print((data.shape))
    print((labels.shape))

    data_train, data_test, labels_train, labels_test = split_dataset(data, labels, 0.9)

    print("Training set shape:", data_train.shape, labels_train.shape)
    print("Testing set shape:", data_test.shape, labels_test.shape)

    dists=distance_matrix(data_train, data_test)

    prediction=knn_predict(dists, labels_train, 4)

    accuracy = evaluate_knn(prediction, labels_test)

    print(accuracy)

if __name__ == "__main__":
    main()

